---
title: Loop and Merge
product: Form Library
description: Learn how to use the Loop and Merge feature to ask the same set of questions for multiple selected items. The loop can adjust dynamically based on user input. View our JavaScript form builder demo to try it firsthand.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/loop-and-merge/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Loop and Merge (Vanilla JS)

Loop and Merge is a feature that allows you to repeat a group of questions and combine the responses into one data object. The loop can either iterate over the same set of questions for each item or adjust dynamically based on user input. In this example, you can select one or multiple SurveyJS products, and the survey will then ask a series of repeating questions about each selected product.

## Supported Question Types

A question loop can be created using one of the complex question types:

- [Single-Select Matrix](/form-library/examples/single-selection-matrix-table-question/)
- [Multi-Select Matrix](/form-library/examples/multi-select-matrix-question/)
- [Dynamic Matrix](/form-library/examples/dynamic-matrix-add-new-rows/)
- [Dynamic Panel](/form-library/examples/duplicate-group-of-fields-in-form/)

Single- and Multi-Select Matrices produce a predefined number of loops&mdash;one for each matrix row. In contrast, Dynamic Matrix and Dynamic Panel types allow users to add new entries during the survey, generating new loops on the fly.

This example demonstrates a question loop based on a Dynamic Matrix. The number of loops is determined by the number of choices selected in a Checkboxes question, which acts as the loop driver.

## Merge Question Values

To generate a single data object or data array, the loop driving question (Checkboxes) must be linked to the looping question (Dynamic Matrix). To create this connection, assign the same value to the [`valueName`](https://surveyjs.io/form-library/documentation/api-reference/question#valueName) property for both questions. This shared value determines the name of the resulting data object or array. In this demo, `valueName` is set to `"surveyjs-products"`.

If the paired question types return different data formats, additional configuration is needed for merging. For example, a Dynamic Matrix returns an array of objects, while a Checkboxes question typically returns an array of strings. To enable merging, configure the Checkboxes question to return an array of objects by setting the [`valuePropertyName`](https://surveyjs.io/form-library/documentation/api-reference/checkbox-question-model#valuePropertyName) property. For instance, if the Checkboxes question lists products, set `valuePropertyName` to `product`. Each selected item will then be saved as an object with the `product` field containing the selected value.

## Configure the Loop

### Enable the Input-Per-Page Mode 

Loop and Merge requires the survey structure to change and display only one input field per survey page. To enable this structure, set the [`questionsOnPageMode`](/form-library/documentation/api-reference/survey-data-model#questionsOnPageMode) property to `"inputPerPage"` at the survey level.

### Configure Dynamic View Titles

Each step in a loop displays a title. In Multi-Select and Dynamic Matrices, you can customize the title using the [`singleInputTitleTemplate`](/form-library/documentation/api-reference/matrix-table-with-dropdown-list#singleInputTitleTemplate) property. This property supports dynamic placeholders (`{rowIndex}`, `{visibleRowIndex}`, `{rowName}`, and `{rowTitle}`) and text piping from matrix cells and other survey questions.

### Disallow Creating New Loops

The Dynamic Matrix question type allows users to add new rows&mdash;effectively creating new loops. However, if the number of loops is already determined by the selections in a loop driving question (such as a Checkboxes question), this feature becomes redundant. Disable it by setting the [`allowAddRows`](https://surveyjs.io/form-library/documentation/api-reference/dynamic-matrix-table-question-model#allowAddRows) property to `false` in the Dynamic Matrix configuration and set the initial number of rows to zero by assigning 0 to the [`rowCount`](https://surveyjs.io/form-library/documentation/api-reference/dynamic-matrix-table-question-model#rowCount) property.

If you want to use a Dynamic Panel for the loop, refer to the following example for detailed instructions:

[Breakable Loop](/form-library/examples/breakable-loop/ (linkStyle))

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "questionsOnPageMode": "inputPerPage",
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "checkbox",
          "name": "products",
          "title": "Which SurveyJS products have you used?",
          "valueName": "surveyjs-products",
          "choices": [
            {
              "value": "form-library",
              "text": "Form Library"
            },
            {
              "value": "survey-creator",
              "text": "Survey Creator"
            },
            {
              "value": "dashboard",
              "text": "Dashboard"
            },
            {
              "value": "pdf-generator",
              "text": "PDF Generator"
            }
          ],
          "valuePropertyName": "product"
        },
        {
          "type": "matrixdynamic",
          "name": "product-feedback",
          "title": "Please leave your feedback on selected products",
          "valueName": "surveyjs-products",
          "singleInputTitleTemplate": "Product: {row.product}",
          "columns": [
            {
              "name": "csat",
              "title": "How satisfied are you with the product?",
              "cellType": "rating",
              "rateType": "smileys",
              "scaleColorMode": "colored"
            },
            {
              "name": "valued-features",
              "title": "What product features do you value the most?",
              "cellType": "comment"
            },
            {
              "name": "improvements",
              "title": "What would you improve in the product?",
              "cellType": "comment"
            }
          ],
          "allowAddRows": false,
          "rowCount": 0
        },
        {
          "type": "radiogroup",
          "name": "agreed-on-follow-up",
          "visibleIf": "{surveyjs-products} anyof ['form-library', 'survey-creator', 'dashboard', 'pdf-generator']",
          "title": "Would you mind if we contact you for a follow up?",
          "choices": [
            {
              "value": "yes",
              "text": "Sure!"
            },
            {
              "value": "no",
              "text": "No"
            }
          ]
        },
        {
          "type": "text",
          "name": "email",
          "visibleIf": "{agreed-on-follow-up} = 'yes'",
          "title": "What is your email address?"
        }
      ]
    }
  ],
  "completedHtml": "<h3>Thank you for your feedback!</h3>"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/loop-and-merge/angular.md)
- [React](https://surveyjs.io/form-library/examples/loop-and-merge/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/loop-and-merge/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/loop-and-merge/jquery.md)


---
title: Loop and Merge
product: Form Library
description: Learn how to use the Loop and Merge feature to ask the same set of questions for multiple selected items. The loop can adjust dynamically based on user input. View our JavaScript form builder demo to try it firsthand.
framework: Angular
source: https://surveyjs.io/form-library/examples/loop-and-merge/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Loop and Merge (Angular)

Loop and Merge is a feature that allows you to repeat a group of questions and combine the responses into one data object. The loop can either iterate over the same set of questions for each item or adjust dynamically based on user input. In this example, you can select one or multiple SurveyJS products, and the survey will then ask a series of repeating questions about each selected product.

## Supported Question Types

A question loop can be created using one of the complex question types:

- [Single-Select Matrix](/form-library/examples/single-selection-matrix-table-question/)
- [Multi-Select Matrix](/form-library/examples/multi-select-matrix-question/)
- [Dynamic Matrix](/form-library/examples/dynamic-matrix-add-new-rows/)
- [Dynamic Panel](/form-library/examples/duplicate-group-of-fields-in-form/)

Single- and Multi-Select Matrices produce a predefined number of loops&mdash;one for each matrix row. In contrast, Dynamic Matrix and Dynamic Panel types allow users to add new entries during the survey, generating new loops on the fly.

This example demonstrates a question loop based on a Dynamic Matrix. The number of loops is determined by the number of choices selected in a Checkboxes question, which acts as the loop driver.

## Merge Question Values

To generate a single data object or data array, the loop driving question (Checkboxes) must be linked to the looping question (Dynamic Matrix). To create this connection, assign the same value to the [`valueName`](https://surveyjs.io/form-library/documentation/api-reference/question#valueName) property for both questions. This shared value determines the name of the resulting data object or array. In this demo, `valueName` is set to `"surveyjs-products"`.

If the paired question types return different data formats, additional configuration is needed for merging. For example, a Dynamic Matrix returns an array of objects, while a Checkboxes question typically returns an array of strings. To enable merging, configure the Checkboxes question to return an array of objects by setting the [`valuePropertyName`](https://surveyjs.io/form-library/documentation/api-reference/checkbox-question-model#valuePropertyName) property. For instance, if the Checkboxes question lists products, set `valuePropertyName` to `product`. Each selected item will then be saved as an object with the `product` field containing the selected value.

## Configure the Loop

### Enable the Input-Per-Page Mode 

Loop and Merge requires the survey structure to change and display only one input field per survey page. To enable this structure, set the [`questionsOnPageMode`](/form-library/documentation/api-reference/survey-data-model#questionsOnPageMode) property to `"inputPerPage"` at the survey level.

### Configure Dynamic View Titles

Each step in a loop displays a title. In Multi-Select and Dynamic Matrices, you can customize the title using the [`singleInputTitleTemplate`](/form-library/documentation/api-reference/matrix-table-with-dropdown-list#singleInputTitleTemplate) property. This property supports dynamic placeholders (`{rowIndex}`, `{visibleRowIndex}`, `{rowName}`, and `{rowTitle}`) and text piping from matrix cells and other survey questions.

### Disallow Creating New Loops

The Dynamic Matrix question type allows users to add new rows&mdash;effectively creating new loops. However, if the number of loops is already determined by the selections in a loop driving question (such as a Checkboxes question), this feature becomes redundant. Disable it by setting the [`allowAddRows`](https://surveyjs.io/form-library/documentation/api-reference/dynamic-matrix-table-question-model#allowAddRows) property to `false` in the Dynamic Matrix configuration and set the initial number of rows to zero by assigning 0 to the [`rowCount`](https://surveyjs.io/form-library/documentation/api-reference/dynamic-matrix-table-question-model#rowCount) property.

If you want to use a Dynamic Panel for the loop, refer to the following example for detailed instructions:

[Breakable Loop](/form-library/examples/breakable-loop/ (linkStyle))

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "questionsOnPageMode": "inputPerPage",
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "checkbox",
          "name": "products",
          "title": "Which SurveyJS products have you used?",
          "valueName": "surveyjs-products",
          "choices": [
            {
              "value": "form-library",
              "text": "Form Library"
            },
            {
              "value": "survey-creator",
              "text": "Survey Creator"
            },
            {
              "value": "dashboard",
              "text": "Dashboard"
            },
            {
              "value": "pdf-generator",
              "text": "PDF Generator"
            }
          ],
          "valuePropertyName": "product"
        },
        {
          "type": "matrixdynamic",
          "name": "product-feedback",
          "title": "Please leave your feedback on selected products",
          "valueName": "surveyjs-products",
          "singleInputTitleTemplate": "Product: {row.product}",
          "columns": [
            {
              "name": "csat",
              "title": "How satisfied are you with the product?",
              "cellType": "rating",
              "rateType": "smileys",
              "scaleColorMode": "colored"
            },
            {
              "name": "valued-features",
              "title": "What product features do you value the most?",
              "cellType": "comment"
            },
            {
              "name": "improvements",
              "title": "What would you improve in the product?",
              "cellType": "comment"
            }
          ],
          "allowAddRows": false,
          "rowCount": 0
        },
        {
          "type": "radiogroup",
          "name": "agreed-on-follow-up",
          "visibleIf": "{surveyjs-products} anyof ['form-library', 'survey-creator', 'dashboard', 'pdf-generator']",
          "title": "Would you mind if we contact you for a follow up?",
          "choices": [
            {
              "value": "yes",
              "text": "Sure!"
            },
            {
              "value": "no",
              "text": "No"
            }
          ]
        },
        {
          "type": "text",
          "name": "email",
          "visibleIf": "{agreed-on-follow-up} = 'yes'",
          "title": "What is your email address?"
        }
      ]
    }
  ],
  "completedHtml": "<h3>Thank you for your feedback!</h3>"
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/loop-and-merge/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/loop-and-merge/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/loop-and-merge/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/loop-and-merge/vanillajs.md)


---
title: Loop and Merge
product: Form Library
description: Learn how to use the Loop and Merge feature to ask the same set of questions for multiple selected items. The loop can adjust dynamically based on user input. View our JavaScript form builder demo to try it firsthand.
framework: React
source: https://surveyjs.io/form-library/examples/loop-and-merge/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Loop and Merge (React)

Loop and Merge is a feature that allows you to repeat a group of questions and combine the responses into one data object. The loop can either iterate over the same set of questions for each item or adjust dynamically based on user input. In this example, you can select one or multiple SurveyJS products, and the survey will then ask a series of repeating questions about each selected product.

## Supported Question Types

A question loop can be created using one of the complex question types:

- [Single-Select Matrix](/form-library/examples/single-selection-matrix-table-question/)
- [Multi-Select Matrix](/form-library/examples/multi-select-matrix-question/)
- [Dynamic Matrix](/form-library/examples/dynamic-matrix-add-new-rows/)
- [Dynamic Panel](/form-library/examples/duplicate-group-of-fields-in-form/)

Single- and Multi-Select Matrices produce a predefined number of loops&mdash;one for each matrix row. In contrast, Dynamic Matrix and Dynamic Panel types allow users to add new entries during the survey, generating new loops on the fly.

This example demonstrates a question loop based on a Dynamic Matrix. The number of loops is determined by the number of choices selected in a Checkboxes question, which acts as the loop driver.

## Merge Question Values

To generate a single data object or data array, the loop driving question (Checkboxes) must be linked to the looping question (Dynamic Matrix). To create this connection, assign the same value to the [`valueName`](https://surveyjs.io/form-library/documentation/api-reference/question#valueName) property for both questions. This shared value determines the name of the resulting data object or array. In this demo, `valueName` is set to `"surveyjs-products"`.

If the paired question types return different data formats, additional configuration is needed for merging. For example, a Dynamic Matrix returns an array of objects, while a Checkboxes question typically returns an array of strings. To enable merging, configure the Checkboxes question to return an array of objects by setting the [`valuePropertyName`](https://surveyjs.io/form-library/documentation/api-reference/checkbox-question-model#valuePropertyName) property. For instance, if the Checkboxes question lists products, set `valuePropertyName` to `product`. Each selected item will then be saved as an object with the `product` field containing the selected value.

## Configure the Loop

### Enable the Input-Per-Page Mode 

Loop and Merge requires the survey structure to change and display only one input field per survey page. To enable this structure, set the [`questionsOnPageMode`](/form-library/documentation/api-reference/survey-data-model#questionsOnPageMode) property to `"inputPerPage"` at the survey level.

### Configure Dynamic View Titles

Each step in a loop displays a title. In Multi-Select and Dynamic Matrices, you can customize the title using the [`singleInputTitleTemplate`](/form-library/documentation/api-reference/matrix-table-with-dropdown-list#singleInputTitleTemplate) property. This property supports dynamic placeholders (`{rowIndex}`, `{visibleRowIndex}`, `{rowName}`, and `{rowTitle}`) and text piping from matrix cells and other survey questions.

### Disallow Creating New Loops

The Dynamic Matrix question type allows users to add new rows&mdash;effectively creating new loops. However, if the number of loops is already determined by the selections in a loop driving question (such as a Checkboxes question), this feature becomes redundant. Disable it by setting the [`allowAddRows`](https://surveyjs.io/form-library/documentation/api-reference/dynamic-matrix-table-question-model#allowAddRows) property to `false` in the Dynamic Matrix configuration and set the initial number of rows to zero by assigning 0 to the [`rowCount`](https://surveyjs.io/form-library/documentation/api-reference/dynamic-matrix-table-question-model#rowCount) property.

If you want to use a Dynamic Panel for the loop, refer to the following example for detailed instructions:

[Breakable Loop](/form-library/examples/breakable-loop/ (linkStyle))

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "questionsOnPageMode": "inputPerPage",
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "checkbox",
          "name": "products",
          "title": "Which SurveyJS products have you used?",
          "valueName": "surveyjs-products",
          "choices": [
            {
              "value": "form-library",
              "text": "Form Library"
            },
            {
              "value": "survey-creator",
              "text": "Survey Creator"
            },
            {
              "value": "dashboard",
              "text": "Dashboard"
            },
            {
              "value": "pdf-generator",
              "text": "PDF Generator"
            }
          ],
          "valuePropertyName": "product"
        },
        {
          "type": "matrixdynamic",
          "name": "product-feedback",
          "title": "Please leave your feedback on selected products",
          "valueName": "surveyjs-products",
          "singleInputTitleTemplate": "Product: {row.product}",
          "columns": [
            {
              "name": "csat",
              "title": "How satisfied are you with the product?",
              "cellType": "rating",
              "rateType": "smileys",
              "scaleColorMode": "colored"
            },
            {
              "name": "valued-features",
              "title": "What product features do you value the most?",
              "cellType": "comment"
            },
            {
              "name": "improvements",
              "title": "What would you improve in the product?",
              "cellType": "comment"
            }
          ],
          "allowAddRows": false,
          "rowCount": 0
        },
        {
          "type": "radiogroup",
          "name": "agreed-on-follow-up",
          "visibleIf": "{surveyjs-products} anyof ['form-library', 'survey-creator', 'dashboard', 'pdf-generator']",
          "title": "Would you mind if we contact you for a follow up?",
          "choices": [
            {
              "value": "yes",
              "text": "Sure!"
            },
            {
              "value": "no",
              "text": "No"
            }
          ]
        },
        {
          "type": "text",
          "name": "email",
          "visibleIf": "{agreed-on-follow-up} = 'yes'",
          "title": "What is your email address?"
        }
      ]
    }
  ],
  "completedHtml": "<h3>Thank you for your feedback!</h3>"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/loop-and-merge/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/loop-and-merge/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/loop-and-merge/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/loop-and-merge/vanillajs.md)
